/**
 * The Key Device Sensor defines how keyboard keystrokes are inserted into an X3D world.
 * <p> The Scene Access Interface Library (sai) package provides abstract interface classes for each X3D node and statement,
 * in accordance witht the X3D SAI Specification.
 * </p>
 * <p> <i>Warning:</i> these interfaces are primarily for internal use to ensure consistency.
 * Java programmers need only use concrete objects provided by the <code>org.web3d.x3d.jsail</code> classes.
 *</p>
 * <p> Online:
 *     <a href="https://www.web3d.org/specifications/java/X3DJSAIL.html" target="_blank">X3D Java Scene Access Interface Library (X3DJSAIL)</a>
 *     and 
 *     <a href="https://www.web3d.org/specifications/java/javadoc/index.html" target="_blank">X3DJSAIL Javadoc</a>
 * </p>
 * @see java.lang.Package
 * @see <a href="https://stackoverflow.com/questions/22095487/why-is-package-info-java-useful">https://stackoverflow.com/questions/22095487/why-is-package-info-java-useful</a>
 * @see <a href="https://stackoverflow.com/questions/624422/how-do-i-document-packages-in-java">https://stackoverflow.com/questions/624422/how-do-i-document-packages-in-java</a>
 */

package org.web3d.x3d.sai.KeyDeviceSensor;

