var fieldTypes = {"X3DNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DAppearanceChildNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DAppearanceNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DChildNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DBindableNode" : {
	"bindTime" : "SFTime",
	"IS" : "SFNode",
	"isBound" : "SFBool",
	"metadata" : "SFNode",
	"set_bind" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DBackgroundNode" : {
	"bindTime" : "SFTime",
	"groundAngle" : "MFFloat",
	"groundColor" : "MFColor",
	"IS" : "SFNode",
	"isBound" : "SFBool",
	"metadata" : "SFNode",
	"set_bind" : "SFBool",
	"skyAngle" : "MFFloat",
	"skyColor" : "MFColor",
	"transparency" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DFollowerNode" : {
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DChaserNode" : {
	"duration" : "SFTime",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DGeometricPropertyNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DColorNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DVolumeRenderStyleNode" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DComposableVolumeRenderStyleNode" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DGeometryNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DComposedGeometryNode" : {
	"attrib" : "MFNode",
	"ccw" : "SFBool",
	"color" : "SFNode",
	"colorPerVertex" : "SFBool",
	"coord" : "SFNode",
	"fogCoord" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal" : "SFNode",
	"normalPerVertex" : "SFBool",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DCoordinateNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DDamperNode" : {
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"order" : "SFInt32",
	"tau" : "SFTime",
	"tolerance" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DSensorNode" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DPointingDeviceSensorNode" : {
	"description" : "SFString",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isOver" : "SFBool",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DDragSensorNode" : {
	"autoOffset" : "SFBool",
	"description" : "SFString",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isOver" : "SFBool",
	"metadata" : "SFNode",
	"trackPoint_changed" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DEnvironmentalSensorNode" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"size" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DTextureNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DEnvironmentTextureNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DFontStyleNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DBoundedObject" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
},
"X3DGroupingNode" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DInfoNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DInterpolatorNode" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"metadata" : "SFNode",
	"set_fraction" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DKeyDeviceSensorNode" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DLayerNode" : {
	"IS" : "SFNode",
	"isPickable" : "SFBool",
	"metadata" : "SFNode",
	"viewport" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DLayoutNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DLightNode" : {
	"ambientIntensity" : "SFFloat",
	"color" : "SFColor",
	"intensity" : "SFFloat",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"on" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DMaterialNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DNBodyCollidableNode" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"rotation" : "SFRotation",
	"translation" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DNBodyCollisionSpaceNode" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DNetworkSensorNode" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DNormalNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DNurbsControlCurveNode" : {
	"controlPoint" : "MFVec2d",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DParametricGeometryNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DNurbsSurfaceGeometryNode" : {
	"controlPoint" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"uClosed" : "SFBool",
	"uDimension" : "SFInt32",
	"uKnot" : "MFDouble",
	"uOrder" : "SFInt32",
	"uTessellation" : "SFInt32",
	"vClosed" : "SFBool",
	"vDimension" : "SFInt32",
	"vKnot" : "MFDouble",
	"vOrder" : "SFInt32",
	"vTessellation" : "SFInt32",
	"weight" : "MFDouble",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DParticleEmitterNode" : {
	"IS" : "SFNode",
	"mass" : "SFFloat",
	"metadata" : "SFNode",
	"speed" : "SFFloat",
	"surfaceArea" : "SFFloat",
	"variation" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DParticlePhysicsModelNode" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DPickSensorNode" : {
	"enabled" : "SFBool",
	"intersectionType" : "SFString",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"matchCriterion" : "SFString",
	"metadata" : "SFNode",
	"objectType" : "MFString",
	"pickedGeometry" : "MFNode",
	"pickingGeometry" : "SFNode",
	"pickTarget" : "MFNode",
	"sortOrder" : "SFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DProductStructureChildNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DPrototypeInstance" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
},
"X3DRigidJointNode" : {
	"body1" : "SFNode",
	"body2" : "SFNode",
	"forceOutput" : "MFString",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DUrlObject" : {
	"url" : "MFString",
},
"X3DScriptNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DSequencerNode" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"metadata" : "SFNode",
	"next" : "SFBool",
	"previous" : "SFBool",
	"set_fraction" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DShaderNode" : {
	"activate" : "SFBool",
	"IS" : "SFNode",
	"isSelected" : "SFBool",
	"isValid" : "SFBool",
	"language" : "SFString",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DShapeNode" : {
	"appearance" : "SFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"geometry" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DSoundNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DTimeDependentNode" : {
	"elapsedTime" : "SFTime",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isPaused" : "SFBool",
	"loop" : "SFBool",
	"metadata" : "SFNode",
	"pauseTime" : "SFTime",
	"resumeTime" : "SFTime",
	"startTime" : "SFTime",
	"stopTime" : "SFTime",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DSoundSourceNode" : {
	"description" : "SFString",
	"duration_changed" : "SFTime",
	"elapsedTime" : "SFTime",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isPaused" : "SFBool",
	"loop" : "SFBool",
	"metadata" : "SFNode",
	"pauseTime" : "SFTime",
	"pitch" : "SFFloat",
	"resumeTime" : "SFTime",
	"startTime" : "SFTime",
	"stopTime" : "SFTime",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DTexture2DNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"repeatS" : "SFBool",
	"repeatT" : "SFBool",
	"textureProperties" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DTexture3DNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"repeatR" : "SFBool",
	"repeatS" : "SFBool",
	"repeatT" : "SFBool",
	"textureProperties" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DTextureCoordinateNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DTextureTransformNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DTouchSensorNode" : {
	"description" : "SFString",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isOver" : "SFBool",
	"metadata" : "SFNode",
	"touchTime" : "SFTime",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DTriggerNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DVertexAttributeNode" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DViewpointNode" : {
	"bindTime" : "SFTime",
	"description" : "SFString",
	"IS" : "SFNode",
	"isBound" : "SFBool",
	"jump" : "SFBool",
	"metadata" : "SFNode",
	"orientation" : "SFRotation",
	"retainUserOffsets" : "SFBool",
	"set_bind" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DViewportNode" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DVolumeDataNode" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"dimensions" : "SFVec3f",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"X3DFogObject" : {
	"color" : "SFColor",
	"fogType" : "SFString",
	"visibilityRange" : "SFFloat",
},
"X3DMetadataObject" : {
	"name" : "SFString",
	"reference" : "SFString",
},
"X3DPickableObject" : {
	"pickable" : "SFBool",
},
"X3DProgrammableShaderObject" : {
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Anchor" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"description" : "SFString",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"parameter" : "MFString",
	"removeChildren" : "MFNode",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Appearance" : {
	"fillProperties" : "SFNode",
	"IS" : "SFNode",
	"lineProperties" : "SFNode",
	"material" : "SFNode",
	"metadata" : "SFNode",
	"pointProperties" : "SFNode",
	"shaders" : "MFNode",
	"texture" : "SFNode",
	"textureTransform" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Arc2D" : {
	"endAngle" : "SFFloat",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"radius" : "SFFloat",
	"startAngle" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ArcClose2D" : {
	"closureType" : "SFString",
	"endAngle" : "SFFloat",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"radius" : "SFFloat",
	"solid" : "SFBool",
	"startAngle" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"AudioClip" : {
	"description" : "SFString",
	"duration_changed" : "SFTime",
	"elapsedTime" : "SFTime",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isPaused" : "SFBool",
	"loop" : "SFBool",
	"metadata" : "SFNode",
	"pauseTime" : "SFTime",
	"pitch" : "SFFloat",
	"resumeTime" : "SFTime",
	"startTime" : "SFTime",
	"stopTime" : "SFTime",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Background" : {
	"backUrl" : "MFString",
	"bindTime" : "SFTime",
	"bottomUrl" : "MFString",
	"frontUrl" : "MFString",
	"groundAngle" : "MFFloat",
	"groundColor" : "MFColor",
	"IS" : "SFNode",
	"isBound" : "SFBool",
	"leftUrl" : "MFString",
	"metadata" : "SFNode",
	"rightUrl" : "MFString",
	"set_bind" : "SFBool",
	"skyAngle" : "MFFloat",
	"skyColor" : "MFColor",
	"topUrl" : "MFString",
	"transparency" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"BallJoint" : {
	"anchorPoint" : "SFVec3f",
	"body1" : "SFNode",
	"body1AnchorPoint" : "SFVec3f",
	"body2" : "SFNode",
	"body2AnchorPoint" : "SFVec3f",
	"forceOutput" : "MFString",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Billboard" : {
	"addChildren" : "MFNode",
	"axisOfRotation" : "SFVec3f",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"BlendedVolumeStyle" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"renderStyle" : "SFNode",
	"voxels" : "SFNode",
	"weightConstant1" : "SFFloat",
	"weightConstant2" : "SFFloat",
	"weightFunction1" : "SFString",
	"weightFunction2" : "SFString",
	"weightTransferFunction1" : "SFNode",
	"weightTransferFunction2" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"BooleanFilter" : {
	"inputFalse" : "SFBool",
	"inputNegate" : "SFBool",
	"inputTrue" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"set_boolean" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"BooleanSequencer" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFBool",
	"metadata" : "SFNode",
	"next" : "SFBool",
	"previous" : "SFBool",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"BooleanToggle" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"set_boolean" : "SFBool",
	"toggle" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"BooleanTrigger" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"set_triggerTime" : "SFTime",
	"triggerTrue" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"BoundaryEnhancementVolumeStyle" : {
	"boundaryOpacity" : "SFFloat",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"opacityFactor" : "SFFloat",
	"retainedOpacity" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"BoundedPhysicsModel" : {
	"enabled" : "SFBool",
	"geometry" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Box" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"size" : "SFVec3f",
	"solid" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CADAssembly" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CADFace" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"shape" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CADLayer" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"removeChildren" : "MFNode",
	"visible" : "MFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CADPart" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"center" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"removeChildren" : "MFNode",
	"rotation" : "SFRotation",
	"scale" : "SFVec3f",
	"scaleOrientation" : "SFRotation",
	"translation" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CartoonVolumeStyle" : {
	"colorSteps" : "SFInt32",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"orthogonalColor" : "SFColorRGBA",
	"parallelColor" : "SFColorRGBA",
	"surfaceNormals" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Circle2D" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"radius" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ClipPlane" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"plane" : "SFVec4f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CollidableOffset" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"collidable" : "SFNode",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"rotation" : "SFRotation",
	"translation" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CollidableShape" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"rotation" : "SFRotation",
	"shape" : "SFNode",
	"translation" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Collision" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"collideTime" : "SFTime",
	"enabled" : "SFBool",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"proxy" : "SFNode",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CollisionCollection" : {
	"appliedParameters" : "MFString",
	"bounce" : "SFFloat",
	"collidables" : "MFNode",
	"enabled" : "SFBool",
	"frictionCoefficients" : "SFVec2f",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"minBounceSpeed" : "SFFloat",
	"slipFactors" : "SFVec2f",
	"softnessConstantForceMix" : "SFFloat",
	"softnessErrorCorrection" : "SFFloat",
	"surfaceSpeed" : "SFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CollisionSensor" : {
	"collider" : "SFNode",
	"contacts" : "MFNode",
	"enabled" : "SFBool",
	"intersections" : "MFNode",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CollisionSpace" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"collidables" : "MFNode",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"useGeometry" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Color" : {
	"color" : "MFColor",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ColorChaser" : {
	"duration" : "SFTime",
	"initialDestination" : "SFColor",
	"initialValue" : "SFColor",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"set_destination" : "SFColor",
	"set_value" : "SFColor",
	"value_changed" : "SFColor",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ColorDamper" : {
	"initialDestination" : "SFColor",
	"initialValue" : "SFColor",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"order" : "SFInt32",
	"set_destination" : "SFColor",
	"set_value" : "SFColor",
	"tau" : "SFTime",
	"tolerance" : "SFFloat",
	"value_changed" : "SFColor",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ColorInterpolator" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFColor",
	"metadata" : "SFNode",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFColor",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ColorRGBA" : {
	"color" : "MFColorRGBA",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ComposedCubeMapTexture" : {
	"back" : "SFNode",
	"bottom" : "SFNode",
	"front" : "SFNode",
	"IS" : "SFNode",
	"left" : "SFNode",
	"metadata" : "SFNode",
	"right" : "SFNode",
	"top" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ComposedShader" : {
	"activate" : "SFBool",
	"field" : "MFNode",
	"IS" : "SFNode",
	"isSelected" : "SFBool",
	"isValid" : "SFBool",
	"language" : "SFString",
	"metadata" : "SFNode",
	"parts" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ComposedTexture3D" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"repeatR" : "SFBool",
	"repeatS" : "SFBool",
	"repeatT" : "SFBool",
	"texture" : "MFNode",
	"textureProperties" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ComposedVolumeStyle" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"renderStyle" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Cone" : {
	"bottom" : "SFBool",
	"bottomRadius" : "SFFloat",
	"height" : "SFFloat",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"side" : "SFBool",
	"solid" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ConeEmitter" : {
	"angle" : "SFFloat",
	"direction" : "SFVec3f",
	"IS" : "SFNode",
	"mass" : "SFFloat",
	"metadata" : "SFNode",
	"position" : "SFVec3f",
	"speed" : "SFFloat",
	"surfaceArea" : "SFFloat",
	"variation" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Contact" : {
	"appliedParameters" : "MFString",
	"body1" : "SFNode",
	"body2" : "SFNode",
	"bounce" : "SFFloat",
	"contactNormal" : "SFVec3f",
	"depth" : "SFFloat",
	"frictionCoefficients" : "SFVec2f",
	"frictionDirection" : "SFVec3f",
	"geometry1" : "SFNode",
	"geometry2" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"minBounceSpeed" : "SFFloat",
	"position" : "SFVec3f",
	"slipCoefficients" : "SFVec2f",
	"softnessConstantForceMix" : "SFFloat",
	"softnessErrorCorrection" : "SFFloat",
	"surfaceSpeed" : "SFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Contour2D" : {
	"addChildren" : "MFNode",
	"children" : "MFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ContourPolyline2D" : {
	"controlPoint" : "MFVec2d",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Coordinate" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"point" : "MFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CoordinateChaser" : {
	"duration" : "SFTime",
	"initialDestination" : "MFVec3f",
	"initialValue" : "MFVec3f",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"set_destination" : "MFVec3f",
	"set_value" : "MFVec3f",
	"value_changed" : "MFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CoordinateDamper" : {
	"initialDestination" : "MFVec3f",
	"initialValue" : "MFVec3f",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"order" : "SFInt32",
	"set_destination" : "MFVec3f",
	"set_value" : "MFVec3f",
	"tau" : "SFTime",
	"tolerance" : "SFFloat",
	"value_changed" : "MFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CoordinateDouble" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"point" : "MFVec3d",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CoordinateInterpolator" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFVec3f",
	"metadata" : "SFNode",
	"set_fraction" : "SFFloat",
	"value_changed" : "MFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CoordinateInterpolator2D" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFVec2f",
	"metadata" : "SFNode",
	"set_fraction" : "SFFloat",
	"value_changed" : "MFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Cylinder" : {
	"bottom" : "SFBool",
	"height" : "SFFloat",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"radius" : "SFFloat",
	"side" : "SFBool",
	"solid" : "SFBool",
	"top" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"CylinderSensor" : {
	"autoOffset" : "SFBool",
	"axisRotation" : "SFRotation",
	"description" : "SFString",
	"diskAngle" : "SFFloat",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isOver" : "SFBool",
	"maxAngle" : "SFFloat",
	"metadata" : "SFNode",
	"minAngle" : "SFFloat",
	"offset" : "SFFloat",
	"rotation_changed" : "SFRotation",
	"trackPoint_changed" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"DirectionalLight" : {
	"ambientIntensity" : "SFFloat",
	"color" : "SFColor",
	"direction" : "SFVec3f",
	"global" : "SFBool",
	"intensity" : "SFFloat",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"on" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"DISEntityManager" : {
	"addedEntities" : "MFNode",
	"address" : "SFString",
	"applicationID" : "SFInt32",
	"IS" : "SFNode",
	"mapping" : "MFNode",
	"metadata" : "SFNode",
	"port" : "SFInt32",
	"removedEntities" : "MFNode",
	"siteID" : "SFInt32",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"DISEntityTypeMapping" : {
	"category" : "SFInt32",
	"country" : "SFInt32",
	"domain" : "SFInt32",
	"extra" : "SFInt32",
	"IS" : "SFNode",
	"kind" : "SFInt32",
	"metadata" : "SFNode",
	"specific" : "SFInt32",
	"subcategory" : "SFInt32",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Disk2D" : {
	"innerRadius" : "SFFloat",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"outerRadius" : "SFFloat",
	"solid" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"DoubleAxisHingeJoint" : {
	"anchorPoint" : "SFVec3f",
	"axis1" : "SFVec3f",
	"axis2" : "SFVec3f",
	"body1" : "SFNode",
	"body1AnchorPoint" : "SFVec3f",
	"body1Axis" : "SFVec3f",
	"body2" : "SFNode",
	"body2AnchorPoint" : "SFVec3f",
	"body2Axis" : "SFVec3f",
	"desiredAngularVelocity1" : "SFFloat",
	"desiredAngularVelocity2" : "SFFloat",
	"forceOutput" : "MFString",
	"hinge1Angle" : "SFFloat",
	"hinge1AngleRate" : "SFFloat",
	"hinge2Angle" : "SFFloat",
	"hinge2AngleRate" : "SFFloat",
	"IS" : "SFNode",
	"maxAngle1" : "SFFloat",
	"maxTorque1" : "SFFloat",
	"maxTorque2" : "SFFloat",
	"metadata" : "SFNode",
	"minAngle1" : "SFFloat",
	"stop1Bounce" : "SFFloat",
	"stop1ConstantForceMix" : "SFFloat",
	"stop1ErrorCorrection" : "SFFloat",
	"suspensionErrorCorrection" : "SFFloat",
	"suspensionForce" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"EaseInEaseOut" : {
	"easeInEaseOut" : "MFVec2f",
	"IS" : "SFNode",
	"key" : "MFFloat",
	"metadata" : "SFNode",
	"modifiedFraction_changed" : "SFFloat",
	"set_fraction" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"EdgeEnhancementVolumeStyle" : {
	"edgeColor" : "SFColorRGBA",
	"enabled" : "SFBool",
	"gradientThreshold" : "SFFloat",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"surfaceNormals" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ElevationGrid" : {
	"attrib" : "MFNode",
	"ccw" : "SFBool",
	"color" : "SFNode",
	"colorPerVertex" : "SFBool",
	"creaseAngle" : "SFFloat",
	"fogCoord" : "SFNode",
	"height" : "MFFloat",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal" : "SFNode",
	"normalPerVertex" : "SFBool",
	"set_height" : "MFFloat",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"xDimension" : "SFInt32",
	"xSpacing" : "SFFloat",
	"zDimension" : "SFInt32",
	"zSpacing" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"EspduTransform" : {
	"addChildren" : "MFNode",
	"address" : "SFString",
	"applicationID" : "SFInt32",
	"articulationParameterArray" : "MFFloat",
	"articulationParameterChangeIndicatorArray" : "MFInt32",
	"articulationParameterCount" : "SFInt32",
	"articulationParameterDesignatorArray" : "MFInt32",
	"articulationParameterIdPartAttachedToArray" : "MFInt32",
	"articulationParameterTypeArray" : "MFInt32",
	"articulationParameterValue0_changed" : "SFFloat",
	"articulationParameterValue1_changed" : "SFFloat",
	"articulationParameterValue2_changed" : "SFFloat",
	"articulationParameterValue3_changed" : "SFFloat",
	"articulationParameterValue4_changed" : "SFFloat",
	"articulationParameterValue5_changed" : "SFFloat",
	"articulationParameterValue6_changed" : "SFFloat",
	"articulationParameterValue7_changed" : "SFFloat",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"center" : "SFVec3f",
	"children" : "MFNode",
	"collideTime" : "SFTime",
	"collisionType" : "SFInt32",
	"deadReckoning" : "SFInt32",
	"detonateTime" : "SFTime",
	"detonationLocation" : "SFVec3f",
	"detonationRelativeLocation" : "SFVec3f",
	"detonationResult" : "SFInt32",
	"enabled" : "SFBool",
	"entityCategory" : "SFInt32",
	"entityCountry" : "SFInt32",
	"entityDomain" : "SFInt32",
	"entityExtra" : "SFInt32",
	"entityID" : "SFInt32",
	"entityKind" : "SFInt32",
	"entitySpecific" : "SFInt32",
	"entitySubcategory" : "SFInt32",
	"eventApplicationID" : "SFInt32",
	"eventEntityID" : "SFInt32",
	"eventNumber" : "SFInt32",
	"eventSiteID" : "SFInt32",
	"fired1" : "SFBool",
	"fired2" : "SFBool",
	"firedTime" : "SFTime",
	"fireMissionIndex" : "SFInt32",
	"firingRange" : "SFFloat",
	"firingRate" : "SFInt32",
	"forceID" : "SFInt32",
	"fuse" : "SFInt32",
	"geoCoords" : "SFVec3d",
	"geoSystem" : "MFString",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isCollided" : "SFBool",
	"isDetonated" : "SFBool",
	"isNetworkReader" : "SFBool",
	"isNetworkWriter" : "SFBool",
	"isRtpHeaderHeard" : "SFBool",
	"isStandAlone" : "SFBool",
	"linearAcceleration" : "SFVec3f",
	"linearVelocity" : "SFVec3f",
	"marking" : "SFString",
	"metadata" : "SFNode",
	"multicastRelayHost" : "SFString",
	"multicastRelayPort" : "SFInt32",
	"munitionApplicationID" : "SFInt32",
	"munitionEndPoint" : "SFVec3f",
	"munitionEntityID" : "SFInt32",
	"munitionQuantity" : "SFInt32",
	"munitionSiteID" : "SFInt32",
	"munitionStartPoint" : "SFVec3f",
	"networkMode" : "SFString",
	"port" : "SFInt32",
	"readInterval" : "SFTime",
	"removeChildren" : "MFNode",
	"rotation" : "SFRotation",
	"rtpHeaderExpected" : "SFBool",
	"scale" : "SFVec3f",
	"scaleOrientation" : "SFRotation",
	"set_articulationParameterValue0" : "SFFloat",
	"set_articulationParameterValue1" : "SFFloat",
	"set_articulationParameterValue2" : "SFFloat",
	"set_articulationParameterValue3" : "SFFloat",
	"set_articulationParameterValue4" : "SFFloat",
	"set_articulationParameterValue5" : "SFFloat",
	"set_articulationParameterValue6" : "SFFloat",
	"set_articulationParameterValue7" : "SFFloat",
	"siteID" : "SFInt32",
	"timestamp" : "SFTime",
	"translation" : "SFVec3f",
	"warhead" : "SFInt32",
	"writeInterval" : "SFTime",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ExplosionEmitter" : {
	"IS" : "SFNode",
	"mass" : "SFFloat",
	"metadata" : "SFNode",
	"position" : "SFVec3f",
	"speed" : "SFFloat",
	"surfaceArea" : "SFFloat",
	"variation" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Extrusion" : {
	"beginCap" : "SFBool",
	"ccw" : "SFBool",
	"convex" : "SFBool",
	"creaseAngle" : "SFFloat",
	"crossSection" : "MFVec2f",
	"endCap" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"orientation" : "MFRotation",
	"scale" : "MFVec2f",
	"set_crossSection" : "MFVec2f",
	"set_orientation" : "MFRotation",
	"set_scale" : "MFVec2f",
	"set_spine" : "MFVec3f",
	"solid" : "SFBool",
	"spine" : "MFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"FillProperties" : {
	"filled" : "SFBool",
	"hatchColor" : "SFColor",
	"hatched" : "SFBool",
	"hatchStyle" : "SFInt32",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"FloatVertexAttribute" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"numComponents" : "SFInt32",
	"value" : "MFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Fog" : {
	"bindTime" : "SFTime",
	"color" : "SFColor",
	"fogType" : "SFString",
	"IS" : "SFNode",
	"isBound" : "SFBool",
	"metadata" : "SFNode",
	"set_bind" : "SFBool",
	"visibilityRange" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"FogCoordinate" : {
	"depth" : "MFFloat",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"FontStyle" : {
	"family" : "MFString",
	"horizontal" : "SFBool",
	"IS" : "SFNode",
	"justify" : "MFString",
	"language" : "SFString",
	"leftToRight" : "SFBool",
	"metadata" : "SFNode",
	"size" : "SFFloat",
	"spacing" : "SFFloat",
	"style" : "SFString",
	"topToBottom" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ForcePhysicsModel" : {
	"enabled" : "SFBool",
	"force" : "SFVec3f",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"GeneratedCubeMapTexture" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"size" : "SFInt32",
	"textureProperties" : "SFNode",
	"update" : "SFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"GeoCoordinate" : {
	"geoOrigin" : "SFNode",
	"geoSystem" : "MFString",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"point" : "MFVec3d",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"GeoElevationGrid" : {
	"ccw" : "SFBool",
	"color" : "SFNode",
	"colorPerVertex" : "SFBool",
	"creaseAngle" : "SFDouble",
	"geoGridOrigin" : "SFVec3d",
	"geoOrigin" : "SFNode",
	"geoSystem" : "MFString",
	"height" : "MFDouble",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal" : "SFNode",
	"normalPerVertex" : "SFBool",
	"set_height" : "MFFloat",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"xDimension" : "SFInt32",
	"xSpacing" : "SFDouble",
	"yScale" : "SFFloat",
	"zDimension" : "SFInt32",
	"zSpacing" : "SFDouble",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"GeoLocation" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"geoCoords" : "SFVec3d",
	"geoOrigin" : "SFNode",
	"geoSystem" : "MFString",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"GeoLOD" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"center" : "SFVec3d",
	"child1Url" : "MFString",
	"child2Url" : "MFString",
	"child3Url" : "MFString",
	"child4Url" : "MFString",
	"children" : "MFNode",
	"geoOrigin" : "SFNode",
	"geoSystem" : "MFString",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"level_changed" : "SFInt32",
	"metadata" : "SFNode",
	"range" : "SFFloat",
	"rootNode" : "MFNode",
	"rootUrl" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"GeoMetadata" : {
	"data" : "MFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"summary" : "MFString",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"GeoOrigin" : {
	"geoCoords" : "SFVec3d",
	"geoSystem" : "MFString",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"rotateYUp" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"GeoPositionInterpolator" : {
	"geoOrigin" : "SFNode",
	"geoSystem" : "MFString",
	"geovalue_changed" : "SFVec3d",
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFVec3d",
	"metadata" : "SFNode",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"GeoProximitySensor" : {
	"center" : "SFVec3d",
	"centerOfRotation_changed" : "SFVec3f",
	"enabled" : "SFBool",
	"enterTime" : "SFTime",
	"exitTime" : "SFTime",
	"geoCenter" : "SFVec3d",
	"geoCoord_changed" : "SFVec3d",
	"geoOrigin" : "SFNode",
	"geoSystem" : "MFString",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"orientation_changed" : "SFRotation",
	"position_changed" : "SFVec3f",
	"size" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"GeoTouchSensor" : {
	"description" : "SFString",
	"enabled" : "SFBool",
	"geoOrigin" : "SFNode",
	"geoSystem" : "MFString",
	"hitGeoCoord_changed" : "SFVec3d",
	"hitNormal_changed" : "SFVec3f",
	"hitPoint_changed" : "SFVec3f",
	"hitTexCoord_changed" : "SFVec2f",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isOver" : "SFBool",
	"metadata" : "SFNode",
	"touchTime" : "SFTime",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"GeoTransform" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"geoCenter" : "SFVec3d",
	"geoOrigin" : "SFNode",
	"geoSystem" : "MFString",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"rotation" : "SFRotation",
	"scale" : "SFVec3f",
	"scaleOrientation" : "SFRotation",
	"translation" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"GeoViewpoint" : {
	"bindTime" : "SFTime",
	"centerOfRotation" : "SFVec3d",
	"description" : "SFString",
	"fieldOfView" : "SFFloat",
	"geoOrigin" : "SFNode",
	"geoSystem" : "MFString",
	"IS" : "SFNode",
	"isBound" : "SFBool",
	"jump" : "SFBool",
	"metadata" : "SFNode",
	"orientation" : "SFRotation",
	"position" : "SFVec3d",
	"retainUserOffsets" : "SFBool",
	"set_bind" : "SFBool",
	"speedFactor" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Group" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"HAnimDisplacer" : {
	"coordIndex" : "MFInt32",
	"description" : "SFString",
	"displacements" : "MFVec3f",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"weight" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"HAnimHumanoid" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"center" : "SFVec3f",
	"description" : "SFString",
	"hidden" : "SFBool",
	"info" : "MFString",
	"IS" : "SFNode",
	"jointBindingPositions" : "MFVec3f",
	"jointBindingRotations" : "MFRotation",
	"jointBindingScales" : "MFVec3f",
	"joints" : "MFNode",
	"loa" : "SFInt32",
	"metadata" : "SFNode",
	"motions" : "MFNode",
	"name" : "SFString",
	"rotation" : "SFRotation",
	"scale" : "SFVec3f",
	"scaleOrientation" : "SFRotation",
	"segments" : "MFNode",
	"sites" : "MFNode",
	"skeletalConfiguration" : "SFString",
	"skeleton" : "MFNode",
	"skin" : "MFNode",
	"skinBindingCoords" : "SFNode",
	"skinBindingNormals" : "SFNode",
	"skinCoord" : "SFNode",
	"skinNormal" : "SFNode",
	"translation" : "SFVec3f",
	"version" : "SFString",
	"viewpoints" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"HAnimJoint" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"center" : "SFVec3f",
	"children" : "MFNode",
	"description" : "SFString",
	"displacers" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"limitOrientation" : "SFRotation",
	"llimit" : "SFVec3f",
	"metadata" : "SFNode",
	"name" : "SFString",
	"removeChildren" : "MFNode",
	"rotation" : "SFRotation",
	"scale" : "SFVec3f",
	"scaleOrientation" : "SFRotation",
	"skinCoordIndex" : "MFInt32",
	"skinCoordWeight" : "MFFloat",
	"stiffness" : "SFVec3f",
	"translation" : "SFVec3f",
	"ulimit" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"HAnimMotion" : {
	"channels" : "MFString",
	"channelsEnabled" : "MFBool",
	"cycleTime" : "SFTime",
	"description" : "SFString",
	"elapsedTime" : "SFTime",
	"enabled" : "SFBool",
	"endFrame" : "SFInt32",
	"frameCount" : "SFInt32",
	"frameDuration" : "SFTime",
	"frameIncrement" : "SFInt32",
	"frameIndex" : "SFInt32",
	"IS" : "SFNode",
	"joints" : "MFString",
	"loa" : "SFInt32",
	"loop" : "SFBool",
	"metadata" : "SFNode",
	"startFrame" : "SFInt32",
	"values" : "MFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"HAnimSegment" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"centerOfMass" : "SFVec3f",
	"children" : "MFNode",
	"coord" : "SFNode",
	"description" : "SFString",
	"displacers" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"mass" : "SFFloat",
	"metadata" : "SFNode",
	"momentsOfInertia" : "MFFloat",
	"name" : "SFString",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"HAnimSite" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"center" : "SFVec3f",
	"children" : "MFNode",
	"description" : "SFString",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"removeChildren" : "MFNode",
	"rotation" : "SFRotation",
	"scale" : "SFVec3f",
	"scaleOrientation" : "SFRotation",
	"translation" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ImageCubeMapTexture" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"textureProperties" : "SFNode",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ImageTexture" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"repeatS" : "SFBool",
	"repeatT" : "SFBool",
	"textureProperties" : "SFNode",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ImageTexture3D" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"repeatR" : "SFBool",
	"repeatS" : "SFBool",
	"repeatT" : "SFBool",
	"textureProperties" : "SFNode",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"IndexedFaceSet" : {
	"attrib" : "MFNode",
	"ccw" : "SFBool",
	"color" : "SFNode",
	"colorIndex" : "MFInt32",
	"colorPerVertex" : "SFBool",
	"convex" : "SFBool",
	"coord" : "SFNode",
	"coordIndex" : "MFInt32",
	"creaseAngle" : "SFFloat",
	"fogCoord" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal" : "SFNode",
	"normalIndex" : "MFInt32",
	"normalPerVertex" : "SFBool",
	"set_colorIndex" : "MFInt32",
	"set_coordIndex" : "MFInt32",
	"set_normalIndex" : "MFInt32",
	"set_texCoordIndex" : "MFInt32",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"texCoordIndex" : "MFInt32",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"IndexedLineSet" : {
	"attrib" : "MFNode",
	"color" : "SFNode",
	"colorIndex" : "MFInt32",
	"colorPerVertex" : "SFBool",
	"coord" : "SFNode",
	"coordIndex" : "MFInt32",
	"fogCoord" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"set_colorIndex" : "MFInt32",
	"set_coordIndex" : "MFInt32",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"IndexedQuadSet" : {
	"attrib" : "MFNode",
	"ccw" : "SFBool",
	"color" : "SFNode",
	"colorPerVertex" : "SFBool",
	"coord" : "SFNode",
	"fogCoord" : "SFNode",
	"index" : "MFInt32",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal" : "SFNode",
	"normalPerVertex" : "SFBool",
	"set_index" : "MFInt32",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"IndexedTriangleFanSet" : {
	"attrib" : "MFNode",
	"ccw" : "SFBool",
	"color" : "SFNode",
	"colorPerVertex" : "SFBool",
	"coord" : "SFNode",
	"fogCoord" : "SFNode",
	"index" : "MFInt32",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal" : "SFNode",
	"normalPerVertex" : "SFBool",
	"set_index" : "MFInt32",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"IndexedTriangleSet" : {
	"attrib" : "MFNode",
	"ccw" : "SFBool",
	"color" : "SFNode",
	"colorPerVertex" : "SFBool",
	"coord" : "SFNode",
	"fogCoord" : "SFNode",
	"index" : "MFInt32",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal" : "SFNode",
	"normalPerVertex" : "SFBool",
	"set_index" : "MFInt32",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"IndexedTriangleStripSet" : {
	"attrib" : "MFNode",
	"ccw" : "SFBool",
	"color" : "SFNode",
	"colorPerVertex" : "SFBool",
	"coord" : "SFNode",
	"fogCoord" : "SFNode",
	"index" : "MFInt32",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal" : "SFNode",
	"normalPerVertex" : "SFBool",
	"set_index" : "MFInt32",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Inline" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"load" : "SFBool",
	"metadata" : "SFNode",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"IntegerSequencer" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFInt32",
	"metadata" : "SFNode",
	"next" : "SFBool",
	"previous" : "SFBool",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFInt32",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"IntegerTrigger" : {
	"integerKey" : "SFInt32",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"set_boolean" : "SFBool",
	"triggerValue" : "SFInt32",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"IsoSurfaceVolumeData" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"contourStepSize" : "SFFloat",
	"dimensions" : "SFVec3f",
	"gradients" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"renderStyle" : "MFNode",
	"surfaceTolerance" : "SFFloat",
	"surfaceValues" : "MFFloat",
	"voxels" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"KeySensor" : {
	"actionKeyPress" : "SFInt32",
	"actionKeyRelease" : "SFInt32",
	"altKey" : "SFBool",
	"controlKey" : "SFBool",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"keyPress" : "SFString",
	"keyRelease" : "SFString",
	"metadata" : "SFNode",
	"shiftKey" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Layer" : {
	"addChildren" : "MFNode",
	"children" : "MFNode",
	"IS" : "SFNode",
	"isPickable" : "SFBool",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"viewport" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"LayerSet" : {
	"activeLayer" : "SFInt32",
	"IS" : "SFNode",
	"layers" : "MFNode",
	"metadata" : "SFNode",
	"order" : "MFInt32",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Layout" : {
	"align" : "MFString",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"offset" : "MFFloat",
	"offsetUnits" : "MFString",
	"scaleMode" : "MFString",
	"size" : "MFFloat",
	"sizeUnits" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"LayoutGroup" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"layout" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"viewport" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"LayoutLayer" : {
	"addChildren" : "MFNode",
	"children" : "MFNode",
	"IS" : "SFNode",
	"isPickable" : "SFBool",
	"layout" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"viewport" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"LinePickSensor" : {
	"enabled" : "SFBool",
	"intersectionType" : "SFString",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"matchCriterion" : "SFString",
	"metadata" : "SFNode",
	"objectType" : "MFString",
	"pickedGeometry" : "MFNode",
	"pickedNormal" : "MFVec3f",
	"pickedPoint" : "MFVec3f",
	"pickedTextureCoordinate" : "MFVec3f",
	"pickingGeometry" : "SFNode",
	"pickTarget" : "MFNode",
	"sortOrder" : "SFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"LineProperties" : {
	"applied" : "SFBool",
	"IS" : "SFNode",
	"linetype" : "SFInt32",
	"linewidthScaleFactor" : "SFFloat",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"LineSet" : {
	"attrib" : "MFNode",
	"color" : "SFNode",
	"coord" : "SFNode",
	"fogCoord" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"vertexCount" : "MFInt32",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"LoadSensor" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isLoaded" : "SFBool",
	"loadTime" : "SFTime",
	"metadata" : "SFNode",
	"progress" : "SFFloat",
	"timeOut" : "SFTime",
	"watchList" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"LocalFog" : {
	"color" : "SFColor",
	"enabled" : "SFBool",
	"fogType" : "SFString",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"visibilityRange" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"LOD" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"center" : "SFVec3f",
	"children" : "MFNode",
	"forceTransitions" : "SFBool",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"level_changed" : "SFInt32",
	"metadata" : "SFNode",
	"range" : "MFFloat",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Material" : {
	"ambientIntensity" : "SFFloat",
	"diffuseColor" : "SFColor",
	"emissiveColor" : "SFColor",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"shininess" : "SFFloat",
	"specularColor" : "SFColor",
	"transparency" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Matrix3VertexAttribute" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"value" : "MFMatrix3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Matrix4VertexAttribute" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"value" : "MFMatrix4f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"MetadataBoolean" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"reference" : "SFString",
	"value" : "MFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"MetadataDouble" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"reference" : "SFString",
	"value" : "MFDouble",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"MetadataFloat" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"reference" : "SFString",
	"value" : "MFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"MetadataInteger" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"reference" : "SFString",
	"value" : "MFInt32",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"MetadataSet" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"reference" : "SFString",
	"value" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"MetadataString" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"reference" : "SFString",
	"value" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"MotorJoint" : {
	"autoCalc" : "SFBool",
	"axis1Angle" : "SFFloat",
	"axis1Torque" : "SFFloat",
	"axis2Angle" : "SFFloat",
	"axis2Torque" : "SFFloat",
	"axis3Angle" : "SFFloat",
	"axis3Torque" : "SFFloat",
	"body1" : "SFNode",
	"body2" : "SFNode",
	"enabledAxes" : "SFInt32",
	"forceOutput" : "MFString",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"motor1Angle" : "SFFloat",
	"motor1AngleRate" : "SFFloat",
	"motor1Axis" : "SFVec3f",
	"motor2Angle" : "SFFloat",
	"motor2AngleRate" : "SFFloat",
	"motor2Axis" : "SFVec3f",
	"motor3Angle" : "SFFloat",
	"motor3AngleRate" : "SFFloat",
	"motor3Axis" : "SFVec3f",
	"stop1Bounce" : "SFFloat",
	"stop1ErrorCorrection" : "SFFloat",
	"stop2Bounce" : "SFFloat",
	"stop2ErrorCorrection" : "SFFloat",
	"stop3Bounce" : "SFFloat",
	"stop3ErrorCorrection" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"MovieTexture" : {
	"description" : "SFString",
	"duration_changed" : "SFTime",
	"elapsedTime" : "SFTime",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isPaused" : "SFBool",
	"loop" : "SFBool",
	"metadata" : "SFNode",
	"pauseTime" : "SFTime",
	"pitch" : "SFFloat",
	"repeatS" : "SFBool",
	"repeatT" : "SFBool",
	"resumeTime" : "SFTime",
	"speed" : "SFFloat",
	"startTime" : "SFTime",
	"stopTime" : "SFTime",
	"textureProperties" : "SFNode",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"MultiTexture" : {
	"alpha" : "SFFloat",
	"color" : "SFColor",
	"function" : "MFString",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"mode" : "MFString",
	"source" : "MFString",
	"texture" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"MultiTextureCoordinate" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"texCoord" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"MultiTextureTransform" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"textureTransform" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NavigationInfo" : {
	"avatarSize" : "MFFloat",
	"bindTime" : "SFTime",
	"headlight" : "SFBool",
	"IS" : "SFNode",
	"isBound" : "SFBool",
	"metadata" : "SFNode",
	"set_bind" : "SFBool",
	"speed" : "SFFloat",
	"transitionComplete" : "SFBool",
	"transitionTime" : "SFTime",
	"transitionType" : "MFString",
	"type" : "MFString",
	"visibilityLimit" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Normal" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"vector" : "MFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NormalInterpolator" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFVec3f",
	"metadata" : "SFNode",
	"set_fraction" : "SFFloat",
	"value_changed" : "MFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NurbsCurve" : {
	"closed" : "SFBool",
	"controlPoint" : "SFNode",
	"IS" : "SFNode",
	"knot" : "MFDouble",
	"metadata" : "SFNode",
	"order" : "SFInt32",
	"tessellation" : "SFInt32",
	"weight" : "MFDouble",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NurbsCurve2D" : {
	"closed" : "SFBool",
	"controlPoint" : "MFVec2d",
	"IS" : "SFNode",
	"knot" : "MFDouble",
	"metadata" : "SFNode",
	"order" : "SFInt32",
	"tessellation" : "SFInt32",
	"weight" : "MFDouble",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NurbsOrientationInterpolator" : {
	"controlPoint" : "SFNode",
	"IS" : "SFNode",
	"knot" : "MFDouble",
	"metadata" : "SFNode",
	"order" : "SFInt32",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFRotation",
	"weight" : "MFDouble",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NurbsPatchSurface" : {
	"controlPoint" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"uClosed" : "SFBool",
	"uDimension" : "SFInt32",
	"uKnot" : "MFDouble",
	"uOrder" : "SFInt32",
	"uTessellation" : "SFInt32",
	"vClosed" : "SFBool",
	"vDimension" : "SFInt32",
	"vKnot" : "MFDouble",
	"vOrder" : "SFInt32",
	"vTessellation" : "SFInt32",
	"weight" : "MFDouble",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NurbsPositionInterpolator" : {
	"controlPoint" : "SFNode",
	"IS" : "SFNode",
	"knot" : "MFDouble",
	"metadata" : "SFNode",
	"order" : "SFInt32",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFVec3f",
	"weight" : "MFDouble",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NurbsSet" : {
	"addGeometry" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"geometry" : "MFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeGeometry" : "MFNode",
	"tessellationScale" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NurbsSurfaceInterpolator" : {
	"controlPoint" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal_changed" : "SFVec3f",
	"position_changed" : "SFVec3f",
	"set_fraction" : "SFVec2f",
	"uDimension" : "SFInt32",
	"uKnot" : "MFDouble",
	"uOrder" : "SFInt32",
	"vDimension" : "SFInt32",
	"vKnot" : "MFDouble",
	"vOrder" : "SFInt32",
	"weight" : "MFDouble",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NurbsSweptSurface" : {
	"ccw" : "SFBool",
	"crossSectionCurve" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"solid" : "SFBool",
	"trajectoryCurve" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NurbsSwungSurface" : {
	"ccw" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"profileCurve" : "SFNode",
	"solid" : "SFBool",
	"trajectoryCurve" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NurbsTextureCoordinate" : {
	"controlPoint" : "MFVec2f",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"uDimension" : "SFInt32",
	"uKnot" : "MFDouble",
	"uOrder" : "SFInt32",
	"vDimension" : "SFInt32",
	"vKnot" : "MFDouble",
	"vOrder" : "SFInt32",
	"weight" : "MFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"NurbsTrimmedSurface" : {
	"addTrimmingContour" : "MFNode",
	"controlPoint" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeTrimmingContour" : "MFNode",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"trimmingContour" : "MFNode",
	"uClosed" : "SFBool",
	"uDimension" : "SFInt32",
	"uKnot" : "MFDouble",
	"uOrder" : "SFInt32",
	"uTessellation" : "SFInt32",
	"vClosed" : "SFBool",
	"vDimension" : "SFInt32",
	"vKnot" : "MFDouble",
	"vOrder" : "SFInt32",
	"vTessellation" : "SFInt32",
	"weight" : "MFDouble",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"OpacityMapVolumeStyle" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"transferFunction" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"OrientationChaser" : {
	"duration" : "SFTime",
	"initialDestination" : "SFRotation",
	"initialValue" : "SFRotation",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"set_destination" : "SFRotation",
	"set_value" : "SFRotation",
	"value_changed" : "SFRotation",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"OrientationDamper" : {
	"initialDestination" : "SFRotation",
	"initialValue" : "SFRotation",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"order" : "SFInt32",
	"set_destination" : "SFRotation",
	"set_value" : "SFRotation",
	"tau" : "SFTime",
	"tolerance" : "SFFloat",
	"value_changed" : "SFRotation",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"OrientationInterpolator" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFRotation",
	"metadata" : "SFNode",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFRotation",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"OrthoViewpoint" : {
	"bindTime" : "SFTime",
	"centerOfRotation" : "SFVec3f",
	"description" : "SFString",
	"fieldOfView" : "MFFloat",
	"IS" : "SFNode",
	"isBound" : "SFBool",
	"jump" : "SFBool",
	"metadata" : "SFNode",
	"orientation" : "SFRotation",
	"position" : "SFVec3f",
	"retainUserOffsets" : "SFBool",
	"set_bind" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PackagedShader" : {
	"activate" : "SFBool",
	"field" : "MFNode",
	"IS" : "SFNode",
	"isSelected" : "SFBool",
	"isValid" : "SFBool",
	"language" : "SFString",
	"metadata" : "SFNode",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ParticleSystem" : {
	"appearance" : "SFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"colorKey" : "MFFloat",
	"colorRamp" : "SFNode",
	"createParticles" : "SFBool",
	"emitter" : "SFNode",
	"enabled" : "SFBool",
	"geometry" : "SFNode",
	"geometry" : "SFNode",
	"geometryType" : "SFString",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"lifetimeVariation" : "SFFloat",
	"maxParticles" : "SFInt32",
	"metadata" : "SFNode",
	"particleLifetime" : "SFFloat",
	"particleSize" : "SFVec2f",
	"physics" : "MFNode",
	"texCoordKey" : "MFFloat",
	"texCoordRamp" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PickableGroup" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"objectType" : "MFString",
	"pickable" : "SFBool",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PixelTexture" : {
	"image" : "SFImage",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"repeatS" : "SFBool",
	"repeatT" : "SFBool",
	"textureProperties" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PixelTexture3D" : {
	"image" : "MFInt32",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"repeatR" : "SFBool",
	"repeatS" : "SFBool",
	"repeatT" : "SFBool",
	"textureProperties" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PlaneSensor" : {
	"autoOffset" : "SFBool",
	"axisRotation" : "SFRotation",
	"description" : "SFString",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isOver" : "SFBool",
	"maxPosition" : "SFVec2f",
	"metadata" : "SFNode",
	"minPosition" : "SFVec2f",
	"offset" : "SFVec3f",
	"trackPoint_changed" : "SFVec3f",
	"translation_changed" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PointEmitter" : {
	"direction" : "SFVec3f",
	"IS" : "SFNode",
	"mass" : "SFFloat",
	"metadata" : "SFNode",
	"position" : "SFVec3f",
	"speed" : "SFFloat",
	"surfaceArea" : "SFFloat",
	"variation" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PointLight" : {
	"ambientIntensity" : "SFFloat",
	"attenuation" : "SFVec3f",
	"color" : "SFColor",
	"global" : "SFBool",
	"intensity" : "SFFloat",
	"IS" : "SFNode",
	"location" : "SFVec3f",
	"metadata" : "SFNode",
	"on" : "SFBool",
	"radius" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PointPickSensor" : {
	"enabled" : "SFBool",
	"intersectionType" : "SFString",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"matchCriterion" : "SFString",
	"metadata" : "SFNode",
	"objectType" : "MFString",
	"pickedGeometry" : "MFNode",
	"pickedPoint" : "MFVec3f",
	"pickingGeometry" : "SFNode",
	"pickTarget" : "MFNode",
	"sortOrder" : "SFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PointProperties" : {
	"colorMode" : "SFString",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"pointSizeAttenuation" : "MFFloat",
	"pointSizeMaxValue" : "SFFloat",
	"pointSizeMinValue" : "SFFloat",
	"pointSizeScaleFactor" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PointSet" : {
	"attrib" : "MFNode",
	"color" : "SFNode",
	"coord" : "SFNode",
	"fogCoord" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Polyline2D" : {
	"IS" : "SFNode",
	"lineSegments" : "MFVec2f",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PolylineEmitter" : {
	"coord" : "SFNode",
	"coordIndex" : "MFInt32",
	"direction" : "SFVec3f",
	"IS" : "SFNode",
	"mass" : "SFFloat",
	"metadata" : "SFNode",
	"set_coordIndex" : "MFInt32",
	"speed" : "SFFloat",
	"surfaceArea" : "SFFloat",
	"variation" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Polypoint2D" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"point" : "MFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PositionChaser" : {
	"duration" : "SFTime",
	"initialDestination" : "SFVec3f",
	"initialValue" : "SFVec3f",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"set_destination" : "SFVec3f",
	"set_value" : "SFVec3f",
	"value_changed" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PositionChaser2D" : {
	"duration" : "SFTime",
	"initialDestination" : "SFVec2f",
	"initialValue" : "SFVec2f",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"set_destination" : "SFVec2f",
	"set_value" : "SFVec2f",
	"value_changed" : "SFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PositionDamper" : {
	"initialDestination" : "SFVec3f",
	"initialValue" : "SFVec3f",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"order" : "SFInt32",
	"set_destination" : "SFVec3f",
	"set_value" : "SFVec3f",
	"tau" : "SFTime",
	"tolerance" : "SFFloat",
	"value_changed" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PositionDamper2D" : {
	"initialDestination" : "SFVec2f",
	"initialValue" : "SFVec2f",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"order" : "SFInt32",
	"set_destination" : "SFVec2f",
	"set_value" : "SFVec2f",
	"tau" : "SFTime",
	"tolerance" : "SFFloat",
	"value_changed" : "SFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PositionInterpolator" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFVec3f",
	"metadata" : "SFNode",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PositionInterpolator2D" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFVec2f",
	"metadata" : "SFNode",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"PrimitivePickSensor" : {
	"enabled" : "SFBool",
	"intersectionType" : "SFString",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"matchCriterion" : "SFString",
	"metadata" : "SFNode",
	"objectType" : "MFString",
	"pickedGeometry" : "MFNode",
	"pickingGeometry" : "SFNode",
	"pickTarget" : "MFNode",
	"sortOrder" : "SFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ProgramShader" : {
	"activate" : "SFBool",
	"IS" : "SFNode",
	"isSelected" : "SFBool",
	"isValid" : "SFBool",
	"language" : "SFString",
	"metadata" : "SFNode",
	"programs" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ProjectionVolumeStyle" : {
	"enabled" : "SFBool",
	"intensityThreshold" : "SFFloat",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"type" : "SFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ProtoInstance" : {
	"fieldValue" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"name" : "SFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ProximitySensor" : {
	"center" : "SFVec3f",
	"centerOfRotation_changed" : "SFVec3f",
	"enabled" : "SFBool",
	"enterTime" : "SFTime",
	"exitTime" : "SFTime",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"orientation_changed" : "SFRotation",
	"position_changed" : "SFVec3f",
	"size" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"QuadSet" : {
	"attrib" : "MFNode",
	"ccw" : "SFBool",
	"color" : "SFNode",
	"colorPerVertex" : "SFBool",
	"coord" : "SFNode",
	"fogCoord" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal" : "SFNode",
	"normalPerVertex" : "SFBool",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ReceiverPdu" : {
	"address" : "SFString",
	"applicationID" : "SFInt32",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"enabled" : "SFBool",
	"entityID" : "SFInt32",
	"geoCoords" : "SFVec3d",
	"geoSystem" : "MFString",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isNetworkReader" : "SFBool",
	"isNetworkWriter" : "SFBool",
	"isRtpHeaderHeard" : "SFBool",
	"isStandAlone" : "SFBool",
	"metadata" : "SFNode",
	"multicastRelayHost" : "SFString",
	"multicastRelayPort" : "SFInt32",
	"networkMode" : "SFString",
	"port" : "SFInt32",
	"radioID" : "SFInt32",
	"readInterval" : "SFTime",
	"receivedPower" : "SFFloat",
	"receiverState" : "SFInt32",
	"rtpHeaderExpected" : "SFBool",
	"siteID" : "SFInt32",
	"timestamp" : "SFTime",
	"transmitterApplicationID" : "SFInt32",
	"transmitterEntityID" : "SFInt32",
	"transmitterRadioID" : "SFInt32",
	"transmitterSiteID" : "SFInt32",
	"whichGeometry" : "SFInt32",
	"writeInterval" : "SFTime",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Rectangle2D" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"size" : "SFVec2f",
	"solid" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"RigidBody" : {
	"angularDampingFactor" : "SFFloat",
	"angularVelocity" : "SFVec3f",
	"autoDamp" : "SFBool",
	"autoDisable" : "SFBool",
	"centerOfMass" : "SFVec3f",
	"disableAngularSpeed" : "SFFloat",
	"disableLinearSpeed" : "SFFloat",
	"disableTime" : "SFTime",
	"enabled" : "SFBool",
	"finiteRotationAxis" : "SFVec3f",
	"fixed" : "SFBool",
	"forces" : "MFVec3f",
	"geometry" : "MFNode",
	"inertia" : "SFMatrix3f",
	"IS" : "SFNode",
	"linearDampingFactor" : "SFFloat",
	"linearVelocity" : "SFVec3f",
	"mass" : "SFFloat",
	"massDensityModel" : "SFNode",
	"metadata" : "SFNode",
	"orientation" : "SFRotation",
	"position" : "SFVec3f",
	"torques" : "MFVec3f",
	"useFiniteRotation" : "SFBool",
	"useGlobalGravity" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"RigidBodyCollection" : {
	"autoDisable" : "SFBool",
	"bodies" : "MFNode",
	"collider" : "SFNode",
	"constantForceMix" : "SFFloat",
	"contactSurfaceThickness" : "SFFloat",
	"disableAngularSpeed" : "SFFloat",
	"disableLinearSpeed" : "SFFloat",
	"disableTime" : "SFTime",
	"enabled" : "SFBool",
	"errorCorrection" : "SFFloat",
	"gravity" : "SFVec3f",
	"IS" : "SFNode",
	"iterations" : "SFInt32",
	"joints" : "MFNode",
	"maxCorrectionSpeed" : "SFFloat",
	"metadata" : "SFNode",
	"preferAccuracy" : "SFBool",
	"set_contacts" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ScalarChaser" : {
	"duration" : "SFTime",
	"initialDestination" : "SFFloat",
	"initialValue" : "SFFloat",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"set_destination" : "SFFloat",
	"set_value" : "SFFloat",
	"value_changed" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ScalarDamper" : {
	"initialDestination" : "SFFloat",
	"initialValue" : "SFFloat",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"order" : "SFInt32",
	"set_destination" : "SFFloat",
	"set_value" : "SFFloat",
	"tau" : "SFTime",
	"tolerance" : "SFFloat",
	"value_changed" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ScalarInterpolator" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFFloat",
	"metadata" : "SFNode",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ScreenFontStyle" : {
	"family" : "MFString",
	"horizontal" : "SFBool",
	"IS" : "SFNode",
	"justify" : "MFString",
	"language" : "SFString",
	"leftToRight" : "SFBool",
	"metadata" : "SFNode",
	"pointSize" : "SFFloat",
	"spacing" : "SFFloat",
	"style" : "SFString",
	"topToBottom" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ScreenGroup" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Script" : {
	"directOutput" : "SFBool",
	"field" : "MFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"mustEvaluate" : "SFBool",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"SegmentedVolumeData" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"dimensions" : "SFVec3f",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"renderStyle" : "MFNode",
	"segmentEnabled" : "MFBool",
	"segmentIdentifiers" : "SFNode",
	"voxels" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ShadedVolumeStyle" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"lighting" : "SFBool",
	"material" : "SFNode",
	"metadata" : "SFNode",
	"phaseFunction" : "SFString",
	"shadows" : "SFBool",
	"surfaceNormals" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ShaderPart" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"type" : "SFString",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ShaderProgram" : {
	"field" : "MFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"type" : "SFString",
	"url" : "MFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Shape" : {
	"appearance" : "SFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"geometry" : "SFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"SignalPdu" : {
	"address" : "SFString",
	"applicationID" : "SFInt32",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"data" : "MFInt32",
	"dataLength" : "SFInt32",
	"enabled" : "SFBool",
	"encodingScheme" : "SFInt32",
	"entityID" : "SFInt32",
	"geoCoords" : "SFVec3d",
	"geoSystem" : "MFString",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isNetworkReader" : "SFBool",
	"isNetworkWriter" : "SFBool",
	"isRtpHeaderHeard" : "SFBool",
	"isStandAlone" : "SFBool",
	"metadata" : "SFNode",
	"multicastRelayHost" : "SFString",
	"multicastRelayPort" : "SFInt32",
	"networkMode" : "SFString",
	"port" : "SFInt32",
	"radioID" : "SFInt32",
	"readInterval" : "SFTime",
	"rtpHeaderExpected" : "SFBool",
	"sampleRate" : "SFInt32",
	"samples" : "SFInt32",
	"siteID" : "SFInt32",
	"tdlType" : "SFInt32",
	"timestamp" : "SFTime",
	"whichGeometry" : "SFInt32",
	"writeInterval" : "SFTime",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"SilhouetteEnhancementVolumeStyle" : {
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"silhouetteBoundaryOpacity" : "SFFloat",
	"silhouetteRetainedOpacity" : "SFFloat",
	"silhouetteSharpness" : "SFFloat",
	"surfaceNormals" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"SingleAxisHingeJoint" : {
	"anchorPoint" : "SFVec3f",
	"angle" : "SFFloat",
	"angleRate" : "SFFloat",
	"axis" : "SFVec3f",
	"body1" : "SFNode",
	"body1AnchorPoint" : "SFVec3f",
	"body2" : "SFNode",
	"body2AnchorPoint" : "SFVec3f",
	"forceOutput" : "MFString",
	"IS" : "SFNode",
	"maxAngle" : "SFFloat",
	"metadata" : "SFNode",
	"minAngle" : "SFFloat",
	"stopBounce" : "SFFloat",
	"stopErrorCorrection" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"SliderJoint" : {
	"axis" : "SFVec3f",
	"body1" : "SFNode",
	"body2" : "SFNode",
	"forceOutput" : "MFString",
	"IS" : "SFNode",
	"maxSeparation" : "SFFloat",
	"metadata" : "SFNode",
	"minSeparation" : "SFFloat",
	"separation" : "SFFloat",
	"separationRate" : "SFFloat",
	"sliderForce" : "SFFloat",
	"stopBounce" : "SFFloat",
	"stopErrorCorrection" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Sound" : {
	"direction" : "SFVec3f",
	"intensity" : "SFFloat",
	"IS" : "SFNode",
	"location" : "SFVec3f",
	"maxBack" : "SFFloat",
	"maxFront" : "SFFloat",
	"metadata" : "SFNode",
	"minBack" : "SFFloat",
	"minFront" : "SFFloat",
	"priority" : "SFFloat",
	"source" : "SFNode",
	"spatialize" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Sphere" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"radius" : "SFFloat",
	"solid" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"SphereSensor" : {
	"autoOffset" : "SFBool",
	"description" : "SFString",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isOver" : "SFBool",
	"metadata" : "SFNode",
	"offset" : "SFRotation",
	"rotation_changed" : "SFRotation",
	"trackPoint_changed" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"SplinePositionInterpolator" : {
	"closed" : "SFBool",
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFVec3f",
	"keyVelocity" : "MFVec3f",
	"metadata" : "SFNode",
	"normalizeVelocity" : "SFBool",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"SplinePositionInterpolator2D" : {
	"closed" : "SFBool",
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFVec2f",
	"keyVelocity" : "MFVec2f",
	"metadata" : "SFNode",
	"normalizeVelocity" : "SFBool",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"SplineScalarInterpolator" : {
	"closed" : "SFBool",
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFFloat",
	"keyVelocity" : "MFFloat",
	"metadata" : "SFNode",
	"normalizeVelocity" : "SFBool",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"SpotLight" : {
	"ambientIntensity" : "SFFloat",
	"attenuation" : "SFVec3f",
	"beamWidth" : "SFFloat",
	"color" : "SFColor",
	"cutOffAngle" : "SFFloat",
	"direction" : "SFVec3f",
	"global" : "SFBool",
	"intensity" : "SFFloat",
	"IS" : "SFNode",
	"location" : "SFVec3f",
	"metadata" : "SFNode",
	"on" : "SFBool",
	"radius" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"SquadOrientationInterpolator" : {
	"IS" : "SFNode",
	"key" : "MFFloat",
	"keyValue" : "MFRotation",
	"metadata" : "SFNode",
	"normalizeVelocity" : "SFBool",
	"set_fraction" : "SFFloat",
	"value_changed" : "SFRotation",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"StaticGroup" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"StringSensor" : {
	"deletionAllowed" : "SFBool",
	"enabled" : "SFBool",
	"enteredText" : "SFString",
	"finalText" : "SFString",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"SurfaceEmitter" : {
	"coordIndex" : "MFInt32",
	"IS" : "SFNode",
	"mass" : "SFFloat",
	"metadata" : "SFNode",
	"set_coordIndex" : "MFInt32",
	"speed" : "SFFloat",
	"surface" : "SFNode",
	"surfaceArea" : "SFFloat",
	"variation" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Switch" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"whichChoice" : "SFInt32",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TexCoordChaser2D" : {
	"duration" : "SFTime",
	"initialDestination" : "MFVec2f",
	"initialValue" : "MFVec2f",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"set_destination" : "MFVec2f",
	"set_value" : "MFVec2f",
	"value_changed" : "MFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TexCoordDamper2D" : {
	"initialDestination" : "MFVec2f",
	"initialValue" : "MFVec2f",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"order" : "SFInt32",
	"set_destination" : "MFVec2f",
	"set_value" : "MFVec2f",
	"tau" : "SFTime",
	"tolerance" : "SFFloat",
	"value_changed" : "MFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Text" : {
	"fontStyle" : "SFNode",
	"IS" : "SFNode",
	"length" : "MFFloat",
	"lineBounds" : "MFVec2f",
	"maxExtent" : "SFFloat",
	"metadata" : "SFNode",
	"origin" : "SFVec3f",
	"solid" : "SFBool",
	"string" : "MFString",
	"textBounds" : "SFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TextureBackground" : {
	"backTexture" : "SFNode",
	"bindTime" : "SFTime",
	"bottomTexture" : "SFNode",
	"frontTexture" : "SFNode",
	"groundAngle" : "MFFloat",
	"groundColor" : "MFColor",
	"IS" : "SFNode",
	"isBound" : "SFBool",
	"leftTexture" : "SFNode",
	"metadata" : "SFNode",
	"rightTexture" : "SFNode",
	"set_bind" : "SFBool",
	"skyAngle" : "MFFloat",
	"skyColor" : "MFColor",
	"topTexture" : "SFNode",
	"transparency" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TextureCoordinate" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"point" : "MFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TextureCoordinate3D" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"point" : "MFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TextureCoordinate4D" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"point" : "MFVec4f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TextureCoordinateGenerator" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"mode" : "SFString",
	"parameter" : "MFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TextureProperties" : {
	"anisotropicDegree" : "SFFloat",
	"borderColor" : "SFColorRGBA",
	"borderWidth" : "SFInt32",
	"boundaryModeR" : "SFString",
	"boundaryModeS" : "SFString",
	"boundaryModeT" : "SFString",
	"generateMipMaps" : "SFBool",
	"IS" : "SFNode",
	"magnificationFilter" : "SFString",
	"metadata" : "SFNode",
	"minificationFilter" : "SFString",
	"textureCompression" : "SFString",
	"texturePriority" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TextureTransform" : {
	"center" : "SFVec2f",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"rotation" : "SFFloat",
	"scale" : "SFVec2f",
	"translation" : "SFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TextureTransform3D" : {
	"center" : "SFVec3f",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"rotation" : "SFRotation",
	"scale" : "SFVec3f",
	"translation" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TextureTransformMatrix3D" : {
	"IS" : "SFNode",
	"matrix" : "SFMatrix4f",
	"metadata" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TimeSensor" : {
	"cycleInterval" : "SFTime",
	"cycleTime" : "SFTime",
	"elapsedTime" : "SFTime",
	"enabled" : "SFBool",
	"fraction_changed" : "SFFloat",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isPaused" : "SFBool",
	"loop" : "SFBool",
	"metadata" : "SFNode",
	"pauseTime" : "SFTime",
	"resumeTime" : "SFTime",
	"startTime" : "SFTime",
	"stopTime" : "SFTime",
	"time" : "SFTime",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TimeTrigger" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"set_boolean" : "SFBool",
	"triggerTime" : "SFTime",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ToneMappedVolumeStyle" : {
	"coolColor" : "SFColorRGBA",
	"enabled" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"surfaceNormals" : "SFNode",
	"warmColor" : "SFColorRGBA",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TouchSensor" : {
	"description" : "SFString",
	"enabled" : "SFBool",
	"hitNormal_changed" : "SFVec3f",
	"hitPoint_changed" : "SFVec3f",
	"hitTexCoord_changed" : "SFVec2f",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isOver" : "SFBool",
	"metadata" : "SFNode",
	"touchTime" : "SFTime",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Transform" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"center" : "SFVec3f",
	"children" : "MFNode",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"rotation" : "SFRotation",
	"scale" : "SFVec3f",
	"scaleOrientation" : "SFRotation",
	"translation" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TransformSensor" : {
	"center" : "SFVec3f",
	"enabled" : "SFBool",
	"enterTime" : "SFTime",
	"exitTime" : "SFTime",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"orientation_changed" : "SFRotation",
	"position_changed" : "SFVec3f",
	"size" : "SFVec3f",
	"targetObject" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TransmitterPdu" : {
	"address" : "SFString",
	"antennaLocation" : "SFVec3f",
	"antennaPatternLength" : "SFInt32",
	"antennaPatternType" : "SFInt32",
	"applicationID" : "SFInt32",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"cryptoKeyID" : "SFInt32",
	"cryptoSystem" : "SFInt32",
	"enabled" : "SFBool",
	"entityID" : "SFInt32",
	"frequency" : "SFInt32",
	"geoCoords" : "SFVec3d",
	"geoSystem" : "MFString",
	"inputSource" : "SFInt32",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"isNetworkReader" : "SFBool",
	"isNetworkWriter" : "SFBool",
	"isRtpHeaderHeard" : "SFBool",
	"isStandAlone" : "SFBool",
	"lengthOfModulationParameters" : "SFInt32",
	"metadata" : "SFNode",
	"modulationTypeDetail" : "SFInt32",
	"modulationTypeMajor" : "SFInt32",
	"modulationTypeSpreadSpectrum" : "SFInt32",
	"modulationTypeSystem" : "SFInt32",
	"multicastRelayHost" : "SFString",
	"multicastRelayPort" : "SFInt32",
	"networkMode" : "SFString",
	"port" : "SFInt32",
	"power" : "SFFloat",
	"radioEntityTypeCategory" : "SFInt32",
	"radioEntityTypeCountry" : "SFInt32",
	"radioEntityTypeDomain" : "SFInt32",
	"radioEntityTypeKind" : "SFInt32",
	"radioEntityTypeNomenclature" : "SFInt32",
	"radioEntityTypeNomenclatureVersion" : "SFInt32",
	"radioID" : "SFInt32",
	"readInterval" : "SFTime",
	"relativeAntennaLocation" : "SFVec3f",
	"rtpHeaderExpected" : "SFBool",
	"siteID" : "SFInt32",
	"timestamp" : "SFTime",
	"transmitFrequencyBandwidth" : "SFFloat",
	"transmitState" : "SFInt32",
	"whichGeometry" : "SFInt32",
	"writeInterval" : "SFTime",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TriangleFanSet" : {
	"attrib" : "MFNode",
	"ccw" : "SFBool",
	"color" : "SFNode",
	"colorPerVertex" : "SFBool",
	"coord" : "SFNode",
	"fanCount" : "MFInt32",
	"fogCoord" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal" : "SFNode",
	"normalPerVertex" : "SFBool",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TriangleSet" : {
	"attrib" : "MFNode",
	"ccw" : "SFBool",
	"color" : "SFNode",
	"colorPerVertex" : "SFBool",
	"coord" : "SFNode",
	"fogCoord" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal" : "SFNode",
	"normalPerVertex" : "SFBool",
	"solid" : "SFBool",
	"texCoord" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TriangleSet2D" : {
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"solid" : "SFBool",
	"vertices" : "MFVec2f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TriangleStripSet" : {
	"attrib" : "MFNode",
	"ccw" : "SFBool",
	"color" : "SFNode",
	"colorPerVertex" : "SFBool",
	"coord" : "SFNode",
	"fogCoord" : "SFNode",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"normal" : "SFNode",
	"normalPerVertex" : "SFBool",
	"solid" : "SFBool",
	"stripCount" : "MFInt32",
	"texCoord" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"TwoSidedMaterial" : {
	"ambientIntensity" : "SFFloat",
	"backAmbientIntensity" : "SFFloat",
	"backDiffuseColor" : "SFColor",
	"backEmissiveColor" : "SFColor",
	"backShininess" : "SFFloat",
	"backSpecularColor" : "SFColor",
	"backTransparency" : "SFFloat",
	"diffuseColor" : "SFColor",
	"emissiveColor" : "SFColor",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"separateBackColor" : "SFBool",
	"shininess" : "SFFloat",
	"specularColor" : "SFColor",
	"transparency" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"UniversalJoint" : {
	"anchorPoint" : "SFVec3f",
	"axis1" : "SFVec3f",
	"axis2" : "SFVec3f",
	"body1" : "SFNode",
	"body1AnchorPoint" : "SFVec3f",
	"body1Axis" : "SFVec3f",
	"body2" : "SFNode",
	"body2AnchorPoint" : "SFVec3f",
	"body2Axis" : "SFFloat",
	"forceOutput" : "MFString",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"stop1Bounce" : "SFFloat",
	"stop1ErrorCorrection" : "SFFloat",
	"stop2Bounce" : "SFFloat",
	"stop2ErrorCorrection" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Viewpoint" : {
	"bindTime" : "SFTime",
	"centerOfRotation" : "SFVec3f",
	"description" : "SFString",
	"fieldOfView" : "SFFloat",
	"IS" : "SFNode",
	"isBound" : "SFBool",
	"jump" : "SFBool",
	"metadata" : "SFNode",
	"orientation" : "SFRotation",
	"position" : "SFVec3f",
	"retainUserOffsets" : "SFBool",
	"set_bind" : "SFBool",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"ViewpointGroup" : {
	"center" : "SFVec3f",
	"children" : "MFNode",
	"description" : "SFString",
	"displayed" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"retainUserOffsets" : "SFBool",
	"size" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"Viewport" : {
	"addChildren" : "MFNode",
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"children" : "MFNode",
	"clipBoundary" : "MFFloat",
	"hidden" : "SFBool",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"removeChildren" : "MFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"VisibilitySensor" : {
	"center" : "SFVec3f",
	"enabled" : "SFBool",
	"enterTime" : "SFTime",
	"exitTime" : "SFTime",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"metadata" : "SFNode",
	"size" : "SFVec3f",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"VolumeData" : {
	"bboxCenter" : "SFVec3f",
	"bboxSize" : "SFVec3f",
	"dimensions" : "SFVec3f",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"renderStyle" : "SFNode",
	"voxels" : "SFNode",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"VolumeEmitter" : {
	"coord" : "SFNode",
	"coordIndex" : "MFInt32",
	"direction" : "SFVec3f",
	"internal" : "SFBool",
	"IS" : "SFNode",
	"mass" : "SFFloat",
	"metadata" : "SFNode",
	"set_coordIndex" : "MFInt32",
	"speed" : "SFFloat",
	"surfaceArea" : "SFFloat",
	"variation" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"VolumePickSensor" : {
	"enabled" : "SFBool",
	"intersectionType" : "SFString",
	"IS" : "SFNode",
	"isActive" : "SFBool",
	"matchCriterion" : "SFString",
	"metadata" : "SFNode",
	"objectType" : "MFString",
	"pickedGeometry" : "MFNode",
	"pickingGeometry" : "SFNode",
	"pickTarget" : "MFNode",
	"sortOrder" : "SFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"WindPhysicsModel" : {
	"direction" : "SFVec3f",
	"enabled" : "SFBool",
	"gustiness" : "SFFloat",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"speed" : "SFFloat",
	"turbulence" : "SFFloat",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"WorldInfo" : {
	"info" : "MFString",
	"IS" : "SFNode",
	"metadata" : "SFNode",
	"title" : "SFString",
	"DEF" : "SFString",
	"USE" : "SFString",
	"class" : "SFString",
},
"component" : {
	"level" : "SFInt32",
	"name" : "SFString",
},
"connect" : {
	"nodeField" : "SFString",
	"protoField" : "SFString",
},
"EXPORT" : {
	"AS" : "SFString",
	"localDEF" : "SFString",
},
"ExternProtoDeclare" : {
	"appinfo" : "SFString",
	"documentation" : "SFString",
	"field" : "MFNode",
	"name" : "SFString",
	"url" : "MFString",
},
"field" : {
	"accessType" : "SFString",
	"appinfo" : "SFString",
	"children" : "MFNode",
	"documentation" : "SFString",
	"name" : "SFString",
	"type" : "SFString",
	"value" : "SFString",
},
"fieldValue" : {
	"children" : "MFNode",
	"name" : "SFString",
	"value" : "SFString",
},
"head" : {
	"component" : "MFNode",
	"meta" : "MFNode",
	"unit" : "MFNode",
},
"IMPORT" : {
	"AS" : "SFString",
	"importedDEF" : "SFString",
	"inlineDEF" : "SFString",
},
"IS" : {
	"connect" : "MFNode",
},
"meta" : {
	"content" : "SFString",
	"dir" : "SFString",
	"http-equiv" : "SFString",
	"lang" : "SFString",
	"name" : "SFString",
	"scheme" : "SFString",
},
"ProtoBody" : {
	"children" : "MFNode",
},
"ProtoDeclare" : {
	"appinfo" : "SFString",
	"documentation" : "SFString",
	"name" : "SFString",
	"ProtoBody" : "SFNode",
	"ProtoInterface" : "SFNode",
},
"ProtoInterface" : {
	"field" : "MFNode",
},
"ROUTE" : {
	"fromField" : "SFString",
	"fromNode" : "SFString",
	"toField" : "SFString",
	"toNode" : "SFString",
},
"Scene" : {
	"children" : "MFNode",
},
"unit" : {
	"category" : "SFString",
	"conversionFactor" : "SFDouble",
	"name" : "SFString",
},
"X3D" : {
	"head" : "SFNode",
	"profile" : "SFString",
	"Scene" : "SFNode",
	"version" : "SFString",
},
};if (typeof module === 'object')  {
    module.exports = fieldTypes;
}
